<script>

    import {onMount} from 'svelte'
    import Variant from './Variant.svelte'
    import {API_URL} from './constants'

    let all = 0;
    let variants = [];
    let updateLocked = false;
    let sending = false;
    let first = [];
    let second = [];
    let third = [];

    function get_random() {
        return [1, 2, 3, 4].map(x => (Math.random() * 2000000000).toFixed(0))
    }

    let randomInts = [];

    function handleEditing(event) {
        updateLocked = event.detail
    }

    function handleSending(event) {
        updateLocked = true;
        sending = true
    }

    function handleSent(event) {
        updateLocked = false;
        refresh()
    }

    async function refresh() {
        if (!updateLocked) {
            let response = await fetch(API_URL);
            let json = await response.json();
            sending = false;
            all = json.all;
            variants = json.variants;
            // first = json.variants[0] || [];
            // second = json.variants[1] || [];
            // third = json.variants[2] || [];
            // console.log(first);
            // console.log(second);
            // console.log(third)
        }
    }

    async function refreshImages() {
        if (!updateLocked) {
            randomInts = get_random();
        }
    }

    onMount(async () => {
        sending = true;
        refresh();
        randomInts = get_random();

        const interval = setInterval(refresh, 1000);

        const photoIntervel = setInterval(refreshImages, 1000);

        return () => {
            clearInterval(interval)
        }
    })

</script>

<main>
    <div class="container p-2">
        <div class="row p-2 pb-3">
            <h1>Face ID</h1>
            <div>{all}</div>
        </div>
        {#if sending}
            <div class="row p-2 pb-3">
                <h2>Обработка...</h2>
            </div>
            <!--        {:else if !first && !second && !third === 0}-->
            <!--            <div class="row p-2 pb-3">-->
            <!--                <h2>Не нашел людей перед камерой</h2>-->
            <!--            </div>-->
        {:else if variants.length === 0}
            <div class="row p-2 pb-3">
                <h2>Не нашел людей перед камерой</h2>
            </div>
        {:else}
        <!--            {#if first}-->
            <!--                <Variant-->
            <!--                        cluster={first[0]}-->
            <!--                        count={first[1]}-->
            <!--                        numbers={randomInts}-->
            <!--                        all={all}-->
            <!--                        on:editing={handleEditing}-->
            <!--                        on:datasent={handleSent}-->
            <!--                        on:datasending={handleSending}-->
            <!--                />-->
            <!--            {/if}-->
            <!--            {#if second}-->
            <!--                <Variant-->
            <!--                        cluster={second[0]}-->
            <!--                        count={second[1]}-->
            <!--                        numbers={randomInts}-->
            <!--                        all={all}-->
            <!--                        on:editing={handleEditing}-->
            <!--                        on:datasent={handleSent}-->
            <!--                        on:datasending={handleSending}-->
            <!--                />-->
            <!--            {/if}-->
            <!--            {#if third}-->
            <!--                <Variant-->
            <!--                        cluster={third[0]}-->
            <!--                        count={third[1]}-->
            <!--                        numbers={randomInts}-->
            <!--                        all={all}-->
            <!--                        on:editing={handleEditing}-->
            <!--                        on:datasent={handleSent}-->
            <!--                        on:datasending={handleSending}-->
            <!--                />-->
            <!--            {/if}-->

            {#each variants as variant, index(variant[0]) }
                <Variant
                        cluster={variant[0]}
                        count={variant[1]}
                        numbers={randomInts}
                        all={all}
                        on:editing={handleEditing}
                        on:datasent={handleSent}
                        on:datasending={handleSending}
                />
            {/each}
        {/if}
    </div>



   <div>
   <figure>
    <img src="http://0.0.0.0:8000/webcam">
   </figure>
   </div>




</main>




<style>


    main {
        text-align: left;
        padding: 1em;
        max-width: 240px;
        margin: 0 auto;
    }

    @media (min-width: 640px) {
        main {
            max-width: none;
        }
    }
</style>